; DECLARE SUB Pool (BYVAL VideoBuffer%, BYVAL ForeGround%, BYVAL BackGround%, BYVAL TopSide%, BYVAL BottomSide%, BYVAL LeftSide%, BYVAL RightSide%)

DATA SEGMENT WORD PUBLIC 'DATA'
Ver db ?
UpRight db ?
Hor db 196
UpLeft db 218
DownLeft db 192
DownRight db 217
DATA ENDS
DGROUP GROUP DATA
CODE SEGMENT BYTE PUBLIC 'CODE'
ASSUME CS:CODE, DS:DGROUP
PUBLIC Pool
Pool PROC FAR
PUSH BP
MOV BP, SP
        pushf
        push ds
        push es
        push si
        push di
push ds

cld
mov Ver, 179
mov UpRight, 191
MOV ES, [BP+18]
MOV DX, [BP+10]
MOV BX, [BP+12]
SUB DX, BX
MOV CX, DX
INC CX
MOV SI, BX
MOV BX, [BP+8]
MOV DX, [BP+6]
SUB DX, BX
INC DX
DarkLines2:
PUSH CX
MOV CX, DX
PUSH DX
PUSH BX
MOV AX, SI
DEC AX
DEC BX
ADD BX, BX
MOV DX, 160
MUL DX
ADD AX, BX
MOV DI, AX
POP BX
POP DX
DarkColumns2:
                        mov ah, [bp+14]
                        push cx
                        mov cl, 4
                        shl ah, cl
                        pop cx
        cmp si, [bp+12]
        jz GoToFirstBlot
      ;  push si
      ;  dec si
      ;  cmp si, [bp+12]
      ;  pop si
      ;  jz GoToSecondBlot
        cmp si, [bp+10]
        jnz OutGoToBottom
        jmp GoToBottom
        OutGoToBottom:
      ;  push si
      ;  inc si
      ;  cmp si, [bp+10]
      ;  pop si
      ;  jnz OutGoToAboveBottom
      ;  jmp GoToAboveBottom
      ;  OutGoToAboveBottom:
                cmp cx, dx
                jz FirstColumn
                cmp cx, 1
                jz LastColumn
               ; cmp cx, 2
               ; jz BeforeLastColumn
               ; push dx
               ; dec dx
               ; cmp cx, dx
               ; pop dx
               ; jz SecondColumn
                        mov al, 32
                        add ah, [bp+16]
                jmp short FinishWithColumns
                FirstColumn:
                        mov al, Ver
                        add ah, [bp+16]
                jmp short FinishWithColumns
                SecondColumn:
                        mov al, Ver
                        add ah, [bp+16]
                jmp short FinishWithColumns
                BeforeLastColumn:
                        mov al, Ver
                        add ah, 7
                jmp short FinishWithColumns
                LastColumn:
                        mov al, Ver
                        add ah, 7
                FinishWithColumns:
        jmp Confirm
        GoToFirstBlot:
                cmp cx, dx
                jz FirstColumn2
                cmp cx, 1
                jz LastColumn2
                        mov al, Hor
                        add ah, [bp+16]
                jmp short FinishWithColumns2
                FirstColumn2:
                        mov al, UpLeft
                        add ah, [bp+16]
                jmp short FinishWithColumns2
                LastColumn2:
                        mov al, UpRight
                        add ah, 7
                FinishWithColumns2:
        jmp Confirm
        GoToSecondBlot:
                cmp cx, dx
                jz FirstColumn4
                cmp cx, 1
                jz LastColumn4
                cmp cx, 2
                jz BeforeLastColumn4
                push dx
                dec dx
                cmp cx, dx
                pop dx
                jz SecondColumn4
                        mov al, Hor
                        add ah, [bp+16]
                jmp short FinishWithColumns4
                FirstColumn4:
                        mov al, Ver
                        add ah, 7
                jmp short FinishWithColumns4
                SecondColumn4:
                        mov al, UpLeft
                        add ah, [bp+16]
                jmp short FinishWithColumns4
                BeforeLastColumn4:
                        mov al, UpRight
                        add ah, 7
                jmp short FinishWithColumns4
                LastColumn4:
                        mov al, Ver
                        add ah, [bp+16]
                FinishWithColumns4:
        jmp short Confirm
        GoToAboveBottom:
                cmp cx, dx
                jz FirstColumn5
                cmp cx, 1
                jz LastColumn5
                cmp cx, 2
                jz BeforeLastColumn5
                push dx
                dec dx
                cmp cx, dx
                pop dx
                jz SecondColumn5
                        mov al, Hor
                        add ah, 7
                jmp short FinishWithColumns5
                FirstColumn5:
                        mov al, Ver
                        add ah, 7
                jmp short FinishWithColumns5
                SecondColumn5:
                        mov al, DownLeft
                        add ah, [bp+16]
                jmp short FinishWithColumns5
                BeforeLastColumn5:
                        mov al, DownRight
                        add ah, 7
                jmp short FinishWithColumns5
                LastColumn5:
                        mov al, Ver
                        add ah, [bp+16]
                FinishWithColumns5:
        jmp short Confirm
        GoToBottom:
                cmp cx, dx
                jz FirstColumn3
                cmp cx, 1
                jz LastColumn3
                        mov al, Hor
                        add ah, 7
                jmp short FinishWithColumns3
                FirstColumn3:
                        mov al, DownLeft
                        add ah, [bp+16]
                jmp short FinishWithColumns3
                LastColumn3:
                        mov al, DownRight
                        add ah, 7
                FinishWithColumns3:
        Confirm:
        STOSW
dec cx
cmp cx, 0
jz OutOfDarkColumns2
jmp DarkColumns2
OutOfDarkColumns2:
INC SI
POP CX
dec cx
cmp cx, 0
jz OutOfDarkLines2
jmp DarkLines2
OutOfDarkLines2:

pop ds
        pop di
        pop si
        pop es
        pop ds
        popf
POP BP
RET 14
Pool ENDP
CODE ENDS
END

