'Hey Bustamante Bastuntchik look below and choose good pivot in near future ...
'1] Possible solution is to read in array(REDIM) first 20 elements(check > 20)
'   and sort them with BUBBLE then get 10th for pivot.
'2] I don't understand for MASA_ALA.OBO /start=21 and for DOUBLE MASA_ALA.OBO!

'For 7466 MASA_ALA.OBO and /start=21:
'   pivot = 0010 in Pass#1 stack:0004-0022*2max, 015s, 008MB
'   pivot = 3733 in Pass#1 stack:0060-0046*2max, 024s, 015MB

'Fragment from MASA_ALA.OBO+MASA_ALA.OBO for HIDRUGCO.ALA and
'CHANWA~1 - 3733+3733=7466 elements:
'
'0000003 HIDRUGCO .. zingiber                        - 3730 line
'0000002 HIDRUGCO .. zingiberene                     - 3731 line
'0000001 HIDRUGCO .. zingiberol                      - 3732 line
'0000001 HIDRUGCO .. zizanioides                     - 3733 line
'0000110 CHANWA~1 .. a                               - 3734 line
'0000009 CHANWA~1 .. about                           - 3735 line
'0000001 CHANWA~1 .. academic                        - 3736 line
'0000003 CHANWA~1 .. accept                          - 3737 line
'
'Because of (1 + 7466) \ 2 = 3733 Pivot$ = 'zizanioides' worst choice,
'result is STUPID_way_of_choosing_Pivot -> SUPER_SLOW_SORT ... :< :< :<

'                Indx = Indx + 1
'                Jndx = Jndx - 1
'        END IF
'        PRINT #1, LTRIM$(STR$(Indx)); " "; LTRIM$(STR$(Jndx))
'                                       |
'LOOP UNTIL Indx > Jndx                 |
'                                       |
'3734 7465                              |
'7466 7465                              |
'3734 7464                     <--------
'7465 7464
'3733 7463
'3734 7462
'7463 7462
'3732 7461
'3733 7460
'7461 7460
'3731 7459
'3734 7458
'7459 7458
'3730 7457
'3732 7456
'7457 7456
'3729 7455
'3733 7454
'7455 7454
'3728 7453

TYPE EMMsructure
NumberOfBytes AS LONG
SourceHandle AS INTEGER
SourceOffset AS LONG
TargetHandle AS INTEGER
TargetOffset AS LONG
END TYPE

DECLARE SUB TryXMS3 (LargestBlock&, Total&, Handle%)
DECLARE SUB HIMEMAllocate (BYVAL SizeOfBlock&, Handle%)
DECLARE SUB HIMEMFree (BYVAL HandleNumber%, ErrorStatus%)
DECLARE SUB HIMEMMove (ErrorBL%, BYVAL SegmentOfStructure%, BYVAL OffsetOfStructure%, ErrorStatus%)
DECLARE SUB HIMEMQuery (LargestBlock&, Total&)
DECLARE SUB ToLong (LNG&, BYVAL LW%, BYVAL HW%)
DECLARE FUNCTION FoxDATA$ (Index&, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%)
DECLARE FUNCTION GetDATA$ (ExtractDATAwithThisPointer$)
DECLARE SUB FoxQuickSort (NonInverseFlag%, Quantity&, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%, StringS%, StringL%, EMBoffsetForStack&)
DECLARE SUB Halting ()

DIM XMS AS EMMsructure
DIM Byte AS STRING * 1
DIM Pattern AS STRING * 6
DIM Virtual AS STRING * 1024

COLOR 15
PRINT "SAKURA.EXE, revision 008, written by Svalqyatchx 'Kaze'."
PRINT "Revision note: Virtual_Memory_Simulated_Stack, if overflow_error then HALT."
PRINT "Caution: Very(pivot is chosen from first 20 elements) slow version."
COLOR 7
IF INSTR(COMMAND$, " ") - 1 < 1 THEN GOTO SNTX
MaxLongInt& = 2# * 1024 * 1024 * 1024 - 1
PRINT "Searching for MASAKARI.SS and MASAKARI.SD ..."

        OPEN "masakari.ss" FOR BINARY AS #1
        IF LOF(1) THEN
            CLOSE #1
OPEN "masakari.ss" FOR INPUT AS #1
  LINE INPUT #1, SwapSizeInMB$ ' 0002 = 2MB
CLOSE #1
        ELSE
            CLOSE #1
            KILL "masakari.ss"
            SwapSizeInMB$ = "0000"
        END IF

        OPEN "masakari.sd" FOR BINARY AS #1
        IF LOF(1) THEN
            CLOSE #1
OPEN "masakari.sd" FOR INPUT AS #1
  LINE INPUT #1, SDrv$ ' D:
  SDrv$ = RTRIM$(SDrv$)
CLOSE #1
        ELSE
            CLOSE #1
            KILL "masakari.sd"
            SDrv$ = ""
        END IF

SwapSizeInMB$ = RTRIM$(SwapSizeInMB$)
SwapSizeInMB& = 0
FOR i% = 1 TO 4
  SwapSizeInMB& = SwapSizeInMB& + (ASC(MID$(SwapSizeInMB$, i%, 1)) - ASC("0")) * (10 ^ (4 - i%))
NEXT
IF SwapSizeInMB& = 0 THEN
  CALL TryXMS3(LargestBlock&, Total&, Handle%)
IF Handle% = 0 THEN CALL HIMEMQuery(LargestBlock&, Total&)
IF LargestBlock& < 512 THEN GOTO qUIT
IF Handle% = 0 THEN CALL HIMEMAllocate(LargestBlock&, Handle%)
IF Handle% = 0 THEN GOTO qUIT
PRINT "Allocated XMS memory: "; LTRIM$(STR$(LargestBlock&)); "KB."
RFE$ = LTRIM$(STR$((LargestBlock& * 1024) \ (6 + 4)))
IF LEN(RFE$) > 6 THEN RFE$ = LEFT$(RFE$, LEN(RFE$) - 6) + "," + RIGHT$(RFE$, 6)
RFE2$ = LTRIM$(STR$(MaxLongInt& \ (6 + 4)))
IF LEN(RFE2$) > 6 THEN RFE2$ = LEFT$(RFE2$, LEN(RFE2$) - 6) + "," + RIGHT$(RFE2$, 6)
PRINT "Room for "; RFE$; " elements; Maximum(2GB-1) for "; RFE2$; " elements."
ELSE
OPEN SDrv$ + "masakari.swp" FOR BINARY AS #6
IF LOF(6) <> SwapSizeInMB& * 1024 * 1024 THEN
   CLOSE #6
   KILL SDrv$ + "masakari.swp"
   PRINT "Creating "; SDrv$ + "MASAKARI.SWP ..."
   OPEN SDrv$ + "masakari.swp" FOR BINARY AS #6
   FOR i& = 1 TO SwapSizeInMB& * 1024
      PUT #6, , Virtual$
   NEXT
END IF
PRINT "Allocated HDD memory: "; LTRIM$(STR$(SwapSizeInMB&)); "MB."
RFE$ = LTRIM$(STR$((SwapSizeInMB& * 1024 * 1024) \ (6 + 4)))
IF LEN(RFE$) > 6 THEN RFE$ = LEFT$(RFE$, LEN(RFE$) - 6) + "," + RIGHT$(RFE$, 6)
RFE2$ = LTRIM$(STR$(MaxLongInt& \ (6 + 4)))
IF LEN(RFE2$) > 6 THEN RFE2$ = LEFT$(RFE2$, LEN(RFE2$) - 6) + "," + RIGHT$(RFE2$, 6)
PRINT "Room for "; RFE$; " elements; Maximum(2GB-1) for "; RFE2$; " elements."
END IF

IF INSTR(COMMAND$, "/") THEN
   TwoF$ = RTRIM$(LEFT$(COMMAND$, INSTR(COMMAND$, "/") - 1))
ELSE
   TwoF$ = COMMAND$
END IF

lf$ = LEFT$(TwoF$, INSTR(TwoF$, " ") - 1)
rf$ = RIGHT$(TwoF$, LEN(TwoF$) - INSTR(TwoF$, " "))
PRINT "Input file: "; lf$
PRINT "Output file: "; rf$
        OPEN rf$ FOR BINARY AS #1
        CLOSE #1
        KILL rf$
it$ = TIME$: a! = TIMER
id$ = DATE$
ImmediateAfterHeapEMBoffset& = 0
TotalQSS& = 0
OffseQSS& = 1
OPEN lf$ FOR INPUT AS #4
IF SwapSizeInMB& = 0 THEN
   PRINT "Making SAKURA.QSS(10bytes per element(6-entry,4-stack)) at XMS memory ..."
ELSE
   PRINT "Making SAKURA.QSS(10bytes per element(6-entry,4-stack)) at HDD memory ..."
END IF
DO WHILE NOT EOF(4)
   LINE INPUT #4, Gxrbuwko$: TotalQSS& = TotalQSS& + 1
   GxrLen% = LEN(Gxrbuwko$)

IF SwapSizeInMB& = 0 THEN
  XMS.SourceHandle = 0
  CALL ToLong(XMS.SourceOffset, VARPTR(OffseQSS&), VARSEG(OffseQSS&))
  XMS.NumberOfBytes = 4
  XMS.TargetHandle = Handle%
  XMS.TargetOffset = ImmediateAfterHeapEMBoffset& + (TotalQSS& - 1) * 6
IF LargestBlock& * 1024 < ImmediateAfterHeapEMBoffset& + (TotalQSS&) * 6 THEN
   PRINT "SAKURA: Fatal Error: Memory deficit."
   Halting
END IF
  CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)

  XMS.SourceHandle = 0
  CALL ToLong(XMS.SourceOffset, VARPTR(GxrLen%), VARSEG(GxrLen%))
  XMS.NumberOfBytes = 2
  XMS.TargetHandle = Handle%
  XMS.TargetOffset = ImmediateAfterHeapEMBoffset& + (TotalQSS& - 1) * 6 + 4
IF LargestBlock& * 1024 < ImmediateAfterHeapEMBoffset& + (TotalQSS&) * 6 + 4 THEN
   PRINT "SAKURA: Fatal Error: Memory deficit."
   Halting
END IF
  CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)
ELSE
IF SwapSizeInMB& * 1024 * 1024 < ImmediateAfterHeapEMBoffset& + (TotalQSS&) * 6 THEN
   PRINT "SAKURA: Fatal Error: Memory deficit."
   Halting
END IF
  ' Different Start Position: 0 against 1.
  SEEK #6, ImmediateAfterHeapEMBoffset& + (TotalQSS& - 1) * 6 + 1
  PUT #6, , OffseQSS&
  PUT #6, , GxrLen%
END IF
  
   IF GxrLen% > GxrLenMAX% THEN GxrLenMAX% = GxrLen%
   OffseQSS& = OffseQSS& + GxrLen% + 2 ' CRLF
LOOP
CLOSE #4

IF INSTR(COMMAND$, "/CS") THEN ans$ = "CASE_SENSITIVE" ELSE ans$ = "CASE_UNSENSITIVE"
IF INSTR(COMMAND$, "/START=") THEN
   Opt1% = INSTR(COMMAND$, "/START=")
   Opt1% = Opt1% + LEN("/START=")
   DO WHILE MID$(COMMAND$, Opt1%, 1) >= "0" AND MID$(COMMAND$, Opt1%, 1) <= "9"
   Opt1$ = Opt1$ + MID$(COMMAND$, Opt1%, 1)
   Opt1% = Opt1% + 1
   LOOP
Opt1% = 0
FOR i% = 1 TO LEN(Opt1$)
  Opt1% = Opt1% + (ASC(MID$(Opt1$, i%, 1)) - ASC("0")) * (10 ^ (LEN(Opt1$) - i%))
NEXT
   StringS% = Opt1%
ELSE
   StringS% = 1
END IF
IF INSTR(COMMAND$, "/LENGTH=") THEN
   Opt2% = INSTR(COMMAND$, "/LENGTH=")
   Opt2% = Opt2% + LEN("/LENGTH=")
   DO WHILE MID$(COMMAND$, Opt2%, 1) >= "0" AND MID$(COMMAND$, Opt2%, 1) <= "9"
   Opt2$ = Opt2$ + MID$(COMMAND$, Opt2%, 1)
   Opt2% = Opt2% + 1
   LOOP
Opt2% = 0
FOR i% = 1 TO LEN(Opt2$)
  Opt2% = Opt2% + (ASC(MID$(Opt2$, i%, 1)) - ASC("0")) * (10 ^ (LEN(Opt2$) - i%))
NEXT
   StringL% = Opt2%
ELSE
   StringL% = GxrLenMAX%
END IF

PRINT "Current sort options: "; ans$; " "; "/START="; StringS%; "/LENGTH="; StringL%
NeedeKB& = TotalQSS& / (1024 / 10) + 1
NeedeKB$ = STR$(NeedeKB&)
PRINT "Sorting in two passes"; TotalQSS&; "elements(longest "; LTRIM$(STR$(GxrLenMAX%)); "), needed"; NeedeKB$; "KB ..."
IF SwapSizeInMB& = 0 THEN
IF LargestBlock& * 1024 < (ImmediateAfterHeapEMBoffset& + TotalQSS& * 6) + TotalQSS& * 4 THEN
   PRINT "SAKURA: Fatal Error: Memory deficit."
   Halting
END IF
ELSE
IF SwapSizeInMB& * 1024 * 1024 < (ImmediateAfterHeapEMBoffset& + TotalQSS& * 6) + TotalQSS& * 4 THEN
   PRINT "SAKURA: Fatal Error: Memory deficit."
   Halting
END IF
END IF
OPEN lf$ FOR BINARY AS #7
FoxQuickSort NonInverseFlag%, TotalQSS&, Handle%, ImmediateAfterHeapEMBoffset&, 6, StringS%, StringL%, ImmediateAfterHeapEMBoffset& + TotalQSS& * 6
LOCATE CSRLIN, 1: PRINT "Sorting pass#2 countdown(Quantity&-Right&), StackPtr: "; STRING$(9, "0"); ", "; STRING$(9, "0"); " ...";
CLOSE #7
PRINT "Stack_Nested_Levels i.e. StackPtrMAX& / 2 ="; StackPtrMAX& / 2
RFE$ = LTRIM$(STR$(TotalReadData#))
IF LEN(RFE$) > 6 THEN RFE$ = LEFT$(RFE$, LEN(RFE$) - 6) + "," + RIGHT$(RFE$, 6)
PRINT "TotalReadData# = "; RFE$; " bytes."

PRINT "Looking in SAKURA.QSS and writing "; rf$; " ..."
OPEN lf$ FOR BINARY AS #4
OPEN rf$ FOR BINARY AS #5
FOR Index& = 1 TO TotalQSS&
   Pattern = FoxDATA$(Index&, Handle%, ImmediateAfterHeapEMBoffset&, 6)
   'PatternL& = CVL(LEFT$(Pattern, 4))
   'PatternR% = CVI(RIGHT$(Pattern, 2))
         SEEK #4, CVL(LEFT$(Pattern, 4))
         VarString$ = INPUT$(CVI(RIGHT$(Pattern, 2)) + 2, 4)
            'VarString$ = ""
            'FOR Zaschto% = 1 TO CVI(RIGHT$(Pattern, 2)) + 2
            'GET #4, , Byte$
            'VarString$ = VarString$ + Byte$
            'NEXT
   PUT #5, , VarString$
NEXT
CLOSE #4, #5

'Change in KAZUYA ... glupendrrrrrr
'IF id$ = DATE$ THEN
'   AreAre! = TIMER - a!
'ELSE
'   AreAre! = TIMER + (86400 - a!)
'END IF
   AreAre! = TIMER - a!
IF id$ = DATE$ THEN
ELSE
   AreAre! = TIMER + (86400 - a!)
END IF

IF AreAre! = 0 THEN AreAre! = 1 / 18.2
PRINT "Time: "; it$; " / "; TIME$; " i.e."; STR$(AreAre!); "seconds."
PRINT "SAKURA: Done("; "performance:"; STR$(INT((TotalReadData# / 1024) / (AreAre!))); "KB/s"; ")."
REM PLAY "mb o2l16e o3l16d o3l16d " 'Strange love
REM DO: LOOP WHILE PLAY(0)
GOTO QuitFree

  '   When you use a variable-length string variable, the statement
  '    reads as many bytes as there are characters in the string's value.
  '    For example, the following two statements read 10 bytes from file
  '    number 1:
  '
  '      VarStrings$=STRING$ (10, " ")
  '      GET #1,,VarString$
' ??? Doesn't read, after reading there are still SPACES !!! ???
         'DIM g AS STRING * 6
         'OPEN "c.w" FOR BINARY AS #4
         'VarStrings$ = STRING$(6 + 2, " ") ' CRLF
         'GET #4, 28280, VarString$ 'DOESN'T WORK
         'PRINT VarString$
         'GET #4, 28280, g$ 'WORKS
         'PRINT g$

Failure:
REM PLAY "mbt130 o2l8f p16 o2l8f o2l8d o2l16c o2l16c o2l16d o2l8f o2l16f o2l8d o2l8c o2l8d o2l8a p16 o2l8a p16 o2l8a o3l8c p16" 'Alphaville: Big in Japan
REM DO: LOOP WHILE PLAY(0)
QuitFree:
IF SwapSizeInMB& = 0 THEN CALL HIMEMFree(Handle%, ErrorStatus%): Handle% = 0
qUIT:
DEF SEG = 0
  POKE &H4F0 + 14, 0
  POKE &H4F0 + 15, 0
DEF SEG
IF Handle% THEN GOTO QuitFree
END
SNTX:
PRINT "Example:"
PRINT "C:\KAZE>sakura d:getwords.uw e:getwords.sw [/cs][/start=x][/length=y]"
PRINT "Note1: Format of MASAKARI.SD is for example:"
PRINT "       'z:\temp\' or 'd:\' - it is location of MASAKARI.SWP;"
PRINT "Note2: Format of MASAKARI.SS is for example:"
PRINT "       '0384'(then HDD) or '0000'(then XMS) - it is size of MASAKARI.SWP;"
PRINT "Note3: More Speed: SAKURA.QSS at XMS memory or on THIRD_HARD_DRIVE(defined"
PRINT "       by masakari.sd, must be fastest, in example C:)"
PRINT "Note4: More Speed: 'Input file' on FIRST_HARD_DRIVE in example D:"
PRINT "Note5: More Speed: 'Output file' on SECOND_HARD_DRIVE in example E:"
PRINT "Note6: /cs means CASE_SENSITIVE, default is NON i.e. CASE_UNSENSITIVE"
PRINT "Note7: /start=x means Start_Position_In_String, default is 1"
PRINT "Note8: /length=y means Length_Of_Substring_including_Start_Position, default"
PRINT "       is Length_Of_Longest_String"
PRINT "Note9: Without a DMA HDD access - terrible story, drama."
'sakura.bas

FUNCTION FoxDATA$ (Index&, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%)
SHARED SwapSizeInMB&, Pattern AS STRING * 6
SHARED XMS AS EMMsructure

IF SwapSizeInMB& = 0 THEN
OtnovoBxg$ = SPACE$(MotherStringL%) ' Must be EVEN!
  XMS.SourceHandle = HIMEMhandle%
  XMS.SourceOffset = EMBoffsetOfDATA& + (Index& - 1) * MotherStringL%
  XMS.NumberOfBytes = MotherStringL%
  XMS.TargetHandle = 0
  CALL ToLong(XMS.TargetOffset, SADD(OtnovoBxg$), SSEG(OtnovoBxg$))
  CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)
FoxDATA$ = OtnovoBxg$
ELSE
  ' Different Start Position: 0 against 1.
  GET #6, EMBoffsetOfDATA& + (Index& - 1) * MotherStringL% + 1, Pattern$
FoxDATA$ = Pattern$
END IF
END FUNCTION

DEFLNG A-Z
SUB FoxQuickSort (NonInverseFlag%, Quantity&, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%, StringS%, StringL%, EMBoffsetForStack&)
SHARED SwapSizeInMB&, Pattern AS STRING * 6, ans$
SHARED StackPtrMAX
SHARED XMS AS EMMsructure
DIM Pattern4 AS STRING * 4

'=========== Choose Pivot ===========
BigStepNeeded% = 20 ' Attention: if elements are for example .LBL lines
                    ' 20*960=19200
IF Quantity& >= BigStepNeeded% THEN
   PRINT "Bubble-sorting possible pivots ..."
   REDIM Fayls$(1 TO BigStepNeeded%)
   FOR i% = 1 TO BigStepNeeded%
      dontusesamenames = i% 'for example 'i' and 'i%' BC could surprise!?
      Fayls$(i%) = MID$(GetDATA$(FoxDATA$(dontusesamenames, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%)), StringS%, StringL%)
   NEXT
   FOR i% = BigStepNeeded% TO 2 STEP -1
   FOR j% = i% - 1 TO 1 STEP -1
      IF Fayls$(i%) < Fayls$(j%) THEN
         SWAP Fayls$(i%), Fayls$(j%)
      END IF
   NEXT
   NEXT
END IF
'=========== Choose Pivot ===========

        Left = 1: Right = Quantity&: StackPtr = 0
        ' PUSH Left
                StackPtr = StackPtr + 1
IF SwapSizeInMB& = 0 THEN
                XMS.SourceHandle = 0
                CALL ToLong(XMS.SourceOffset, VARPTR(Left), VARSEG(Left))
                XMS.NumberOfBytes = 4
                XMS.TargetHandle = HIMEMhandle%
                XMS.TargetOffset = EMBoffsetForStack& + (StackPtr - 1) * 4
                CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)
ELSE
  ' Different Start Position: 0 against 1.
  SEEK #6, EMBoffsetForStack& + (StackPtr - 1) * 4 + 1
  'DEF SEG = VARSEG(Left) 'Probably no need!?
  Pattern4$ = CHR$(PEEK(VARPTR(Left))) + CHR$(PEEK(VARPTR(Left) + 1)) + CHR$(PEEK(VARPTR(Left) + 2)) + CHR$(PEEK(VARPTR(Left) + 3))
  'DEF SEG
  PUT #6, , Pattern4$
END IF
        ' PUSH Right
                StackPtr = StackPtr + 1
IF SwapSizeInMB& = 0 THEN
                XMS.SourceHandle = 0
                CALL ToLong(XMS.SourceOffset, VARPTR(Right), VARSEG(Right))
                XMS.NumberOfBytes = 4
                XMS.TargetHandle = HIMEMhandle%
                XMS.TargetOffset = EMBoffsetForStack& + (StackPtr - 1) * 4
                CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)
ELSE
  ' Different Start Position: 0 against 1.
  SEEK #6, EMBoffsetForStack& + (StackPtr - 1) * 4 + 1
  'DEF SEG = VARSEG(Right) 'Probably no need!?
  Pattern4$ = CHR$(PEEK(VARPTR(Right))) + CHR$(PEEK(VARPTR(Right) + 1)) + CHR$(PEEK(VARPTR(Right) + 2)) + CHR$(PEEK(VARPTR(Right) + 3))
  'DEF SEG
  PUT #6, , Pattern4$
END IF

InitialSplitFlag% = 0
DO

      IF InitialSplitFlag% = 1 THEN PRINT
      IF Quantity& <> Right THEN
         SP$ = STRING$(9 - LEN(LTRIM$(STR$(StackPtr))), "0") + LTRIM$(STR$(StackPtr))
         FL$ = LTRIM$(STR$(Quantity& - Right))
         LOCATE CSRLIN, 1: PRINT "Sorting pass#2 countdown(Quantity&-Right&), StackPtr: "; STRING$(9 - LEN(FL$), "0") + FL$; ", "; SP$; " ...";
      END IF

        ' POP Right
IF SwapSizeInMB& = 0 THEN
                XMS.SourceHandle = HIMEMhandle%
                XMS.SourceOffset = EMBoffsetForStack& + (StackPtr - 1) * 4
                XMS.NumberOfBytes = 4
                XMS.TargetHandle = 0
                CALL ToLong(XMS.TargetOffset, VARPTR(Right), VARSEG(Right))
                CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)
ELSE
  ' Different Start Position: 0 against 1.
  SEEK #6, EMBoffsetForStack& + (StackPtr - 1) * 4 + 1
  GET #6, , Pattern4$
  'DEF SEG = VARSEG(Right) 'Probably no need!?
  POKE VARPTR(Right), ASC(MID$(Pattern4$, 1, 1))
  POKE VARPTR(Right) + 1, ASC(MID$(Pattern4$, 2, 1))
  POKE VARPTR(Right) + 2, ASC(MID$(Pattern4$, 3, 1))
  POKE VARPTR(Right) + 3, ASC(MID$(Pattern4$, 4, 1))
  'DEF SEG
END IF
                StackPtr = StackPtr - 1
        ' POP Left
IF SwapSizeInMB& = 0 THEN
                XMS.SourceHandle = HIMEMhandle%
                XMS.SourceOffset = EMBoffsetForStack& + (StackPtr - 1) * 4
                XMS.NumberOfBytes = 4
                XMS.TargetHandle = 0
                CALL ToLong(XMS.TargetOffset, VARPTR(Left), VARSEG(Left))
                CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)
ELSE
  ' Different Start Position: 0 against 1.
  SEEK #6, EMBoffsetForStack& + (StackPtr - 1) * 4 + 1
  GET #6, , Pattern4$
  'DEF SEG = VARSEG(Left) 'Probably no need!?
  POKE VARPTR(Left), ASC(MID$(Pattern4$, 1, 1))
  POKE VARPTR(Left) + 1, ASC(MID$(Pattern4$, 2, 1))
  POKE VARPTR(Left) + 2, ASC(MID$(Pattern4$, 3, 1))
  POKE VARPTR(Left) + 3, ASC(MID$(Pattern4$, 4, 1))
  'DEF SEG
END IF
                StackPtr = StackPtr - 1
DO

      IF InitialSplitFlag% = 0 THEN
      SP$ = STRING$(9 - LEN(LTRIM$(STR$(StackPtr))), "0") + LTRIM$(STR$(StackPtr))
      FL$ = LTRIM$(STR$(Right))
      LOCATE CSRLIN, 1: PRINT "Sorting pass#1(splitting) countdown(Right&), StackPtr: "; STRING$(9 - LEN(FL$), "0") + FL$; ", "; SP$; " ...";
      END IF

IF FirstPivotFlag% = 0 AND Quantity& >= BigStepNeeded% THEN
                pivot$ = Fayls$(BigStepNeeded% \ 2)
                LPivot$ = LCASE$(pivot$)
FirstPivotFlag% = 1
ELSE
                pivot$ = MID$(GetDATA$(FoxDATA$((Left + Right) \ 2, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%)), StringS%, StringL%)
                LPivot$ = LCASE$(pivot$)
END IF
        Indx = Left
        Jndx = Right
DO
IF ans$ = "CASE_SENSITIVE" THEN
DO WHILE MID$(GetDATA$(FoxDATA$(Indx, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%)), StringS%, StringL%) < pivot$
        Indx = Indx + 1
LOOP
DO WHILE MID$(GetDATA$(FoxDATA$(Jndx, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%)), StringS%, StringL%) > pivot$
        Jndx = Jndx - 1
LOOP
ELSE
DO WHILE LCASE$(MID$(GetDATA$(FoxDATA$(Indx, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%)), StringS%, StringL%)) < LPivot$
        Indx = Indx + 1
LOOP
DO WHILE LCASE$(MID$(GetDATA$(FoxDATA$(Jndx, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%)), StringS%, StringL%)) > LPivot$
        Jndx = Jndx - 1
LOOP
END IF
        IF Indx <= Jndx THEN
        IF Indx < Jndx THEN
                ' Jndx -> Temp
                Temp$ = FoxDATA$(Jndx, HIMEMhandle%, EMBoffsetOfDATA&, MotherStringL%)
                ' Indx -> Jndx
IF SwapSizeInMB& = 0 THEN
                XMS.SourceHandle = HIMEMhandle%
                XMS.SourceOffset = EMBoffsetOfDATA& + (Indx - 1) * MotherStringL%
                XMS.NumberOfBytes = MotherStringL%
                XMS.TargetHandle = HIMEMhandle%
                XMS.TargetOffset = EMBoffsetOfDATA& + (Jndx - 1) * MotherStringL%
                CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)
ELSE
  ' Different Start Position: 0 against 1.
  GET #6, EMBoffsetOfDATA& + (Indx - 1) * MotherStringL% + 1, Pattern$
  ' Different Start Position: 0 against 1.
  PUT #6, EMBoffsetOfDATA& + (Jndx - 1) * MotherStringL% + 1, Pattern$
END IF
                ' Temp -> Indx
IF SwapSizeInMB& = 0 THEN
                XMS.SourceHandle = 0
                CALL ToLong(XMS.SourceOffset, SADD(Temp$), SSEG(Temp$))
                XMS.NumberOfBytes = MotherStringL%
                XMS.TargetHandle = HIMEMhandle%
                XMS.TargetOffset = EMBoffsetOfDATA& + (Indx - 1) * MotherStringL%
                CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)
ELSE
  ' Different Start Position: 0 against 1.
  Pattern$ = Temp$
  PUT #6, EMBoffsetOfDATA& + (Indx - 1) * MotherStringL% + 1, Pattern$
END IF
        'NumberOfSwaps& = NumberOfSwaps& + 1
        END IF
                Indx = Indx + 1
                Jndx = Jndx - 1
        END IF
LOOP UNTIL Indx > Jndx

IF Indx < Right THEN
        ' PUSH Indx
                StackPtr = StackPtr + 1
IF SwapSizeInMB& = 0 THEN
                XMS.SourceHandle = 0
                CALL ToLong(XMS.SourceOffset, VARPTR(Indx), VARSEG(Indx))
                XMS.NumberOfBytes = 4
                XMS.TargetHandle = HIMEMhandle%
                XMS.TargetOffset = EMBoffsetForStack& + (StackPtr - 1) * 4
                CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)
ELSE
  ' Different Start Position: 0 against 1.
  SEEK #6, EMBoffsetForStack& + (StackPtr - 1) * 4 + 1
  'DEF SEG = VARSEG(Indx) 'Probably no need!?
  Pattern4$ = CHR$(PEEK(VARPTR(Indx))) + CHR$(PEEK(VARPTR(Indx) + 1)) + CHR$(PEEK(VARPTR(Indx) + 2)) + CHR$(PEEK(VARPTR(Indx) + 3))
  'DEF SEG
  PUT #6, , Pattern4$
END IF
        ' PUSH Right
                StackPtr = StackPtr + 1
                IF StackPtr > StackPtrMAX THEN StackPtrMAX = StackPtr
                IF StackPtrMAX > Quantity& THEN
                  PRINT "SAKURA: Fatal Error: Simulated Stack Overflow i.e. StackPtrMAX& > Quantity&."
                  Halting
                END IF

IF SwapSizeInMB& = 0 THEN
                XMS.SourceHandle = 0
                CALL ToLong(XMS.SourceOffset, VARPTR(Right), VARSEG(Right))
                XMS.NumberOfBytes = 4
                XMS.TargetHandle = HIMEMhandle%
                XMS.TargetOffset = EMBoffsetForStack& + (StackPtr - 1) * 4
                CALL HIMEMMove(ErrorBL%, VARSEG(XMS), VARPTR(XMS), ErrorStatus%)
ELSE
  ' Different Start Position: 0 against 1.
  SEEK #6, EMBoffsetForStack& + (StackPtr - 1) * 4 + 1
  'DEF SEG = VARSEG(Right) 'Probably no need!?
  Pattern4$ = CHR$(PEEK(VARPTR(Right))) + CHR$(PEEK(VARPTR(Right) + 1)) + CHR$(PEEK(VARPTR(Right) + 2)) + CHR$(PEEK(VARPTR(Right) + 3))
  'DEF SEG
  PUT #6, , Pattern4$
END IF
END IF
        Right = Jndx

      IF InitialSplitFlag% = 0 THEN
      SP$ = STRING$(9 - LEN(LTRIM$(STR$(StackPtr))), "0") + LTRIM$(STR$(StackPtr))
      FL$ = LTRIM$(STR$(Right))
      LOCATE CSRLIN, 1: PRINT "Sorting pass#1(splitting) countdown(Right&), StackPtr: "; STRING$(9 - LEN(FL$), "0") + FL$; ", "; SP$; " ...";
      END IF

LOOP UNTIL Left >= Right
IF InitialSplitFlag% = 0 THEN InitialSplitFlag% = 1 ELSE InitialSplitFlag% = 2
LOOP UNTIL StackPtr = 0

END SUB

DEFSNG A-Z
FUNCTION GetDATA$ (ExtractDATAwithThisPointer$)
   SHARED TotalReadData#
   SEEK #7, CVL(LEFT$(ExtractDATAwithThisPointer$, 4))
   GetDATA$ = INPUT$(CVI(RIGHT$(ExtractDATAwithThisPointer$, 2)) + 2, 7)
TotalReadData# = TotalReadData# + CVI(RIGHT$(ExtractDATAwithThisPointer$, 2)) + 2
END FUNCTION

SUB Halting
PRINT "HALT!": DO: LOOP
END SUB

